@dark         : #323232, #ced4da, #f8f9fa;
@dark-left    : #2b2b2b, #272727, #404040, #272725, #005377, #026879,#052f5f;
@dark-top     : extract(@dark-left, 1), extract(@dark-left, 2);
@dark-card    : extract(@dark-left, 1), extract(@dark-left, 2);
@dark-table   : #474747;
@dark-dropdown: #454545, extract(@dark-left, 4);
@dark-button  : extract(@dark, 1), extract(@dark-left, 4), extract(@dark, 3), extract(@dark-left, 5), extract(@dark-left, 6);
@dark-input   : #575757, extract(@dark, 3), extract(@dark, 1), #7a7a7a;

/* palletes:body, left-bg, left-border */
@light: #ebebeb,#002e4e, #003a61,#002e4e, #003a61,#002e4e;
@light-left: #00297a, #00205f, #001744;

.background-and-border(@bg, @bd){
    background-color: @bg !important;
        border-color: @bd !important;
}

.border-top-bottom(@top, @bot){
       border-top-color: @top !important;
    border-bottom-color: @bot !important;
}

.horizontal(@type){
    border-color: if((@type = "dark"), extract(@dark-table, 1),  extract(@light-table, 1)) !important;
}

.left-content(@type){
    /* navigation border */
    @background-hover : if((@type = "dark"), extract(@dark-left, 5),  extract(@light-left, 5));
    @nav-top-hover    : if((@type = "dark"), extract(@dark-left, 6),  extract(@light-left, 6));
    @nav-bot-hover    : if((@type = "dark"), extract(@dark-left, 7),  extract(@light-left, 7));

    .background-and-border(
        if((@type = "dark"), extract(@dark-left, 1),  extract(@light-left, 1)),
        if((@type = "dark"), extract(@dark-left, 2),  extract(@light-left, 2))
    );

    ul.uk-nav{
        > li > a{
            .border-top-bottom(
                if((@type = "dark"), extract(@dark-left, 3),  extract(@light-left, 3)),
                if((@type = "dark"), extract(@dark-left, 4),  extract(@light-left, 4))
            );

            &:hover{
                background-color: @background-hover;
                
                .border-top-bottom(@nav-top-hover, @nav-bot-hover);
            }
        }
        > li.uk-open > a{
            background-color: @background-hover;

            .border-top-bottom(@nav-top-hover, @nav-bot-hover);
        }
    }
}

.top-content(@type){
    .background-and-border(
        if((@type = "dark"), extract(@dark-top, 1),  extract(@light-top, 1)),
        if((@type = "dark"), extract(@dark-top, 2),  extract(@light-top, 2))
    );
}

.card-content(@type){
    .background-and-border(
        if((@type = "dark"), extract(@dark-card, 1),  extract(@light-card, 1)),
        if((@type = "dark"), extract(@dark-card, 2),  extract(@light-card, 2))
    );

    .uk-card-header{
        .horizontal(@type);
    }
}

.dropdown(@type){
    .background-and-border(
        if((@type = "dark"), extract(@dark-dropdown, 1),  extract(@light-dropdown, 1)),
        if((@type = "dark"), extract(@dark-dropdown, 2),  extract(@light-dropdown, 2))
    );
}

.button-default(@type) {
    .background-and-border(
        if((@type = "dark"), extract(@dark-button, 1),  extract(@light-button, 1)),
        if((@type = "dark"), extract(@dark-button, 2),  extract(@light-button, 2))
    );
    color: if((@type = "dark"), extract(@dark-button, 3),  extract(@light-button, 3)) !important;
}

.button-hover(@type){
    .background-and-border(
        if((@type = "dark"), extract(@dark-button, 4),  extract(@light-button, 4)),
        if((@type = "dark"), extract(@dark-button, 5),  extract(@light-button, 5))
    );
}

.input-default(@type){
         color: if((@type = "dark"), extract(@dark-input, 2),  extract(@light-input 2)) !important;
    background: none !important;
  border-color: if((@type = "dark"), extract(@dark-input, 1),  extract(@light-input 1)) !important;
}

.input-default-focus(@type){
    .background-and-border(
        if((@type = "dark"), extract(@dark-input, 3),  extract(@day 2)),
        if((@type = "dark"), extract(@dark-input, 4),  extract(@day 2))
    );
}

.themes(@type){
    /* text palletes */
    @text      : if((@type = "dark"), extract(@dark, 2),  extract(@light, 2));
    @text-hover: if((@type = "dark"), extract(@dark, 3),  extract(@light, 3));

    /* list */
    @table-border: if((@type = "dark"), extract(@dark, 7),  extract(@day-container, 4));


    background-color: if((@type = "dark"), extract(@dark, 1),  extract(@light, 1)) !important;

    p, label, span, h1, h2, h3, h4, h5, h6{
        color: @text !important;
    }

    a{
        color: @text !important;
        text-decoration: none;

        &:hover{
            color: @text-hover !important;
        }
    }

    table tr, hr{
        .horizontal(@type);
    }

    .header-theme{
        .top-content(@type);
    }

    .left-theme{
        .left-content(@type);
    }

    .card-theme{
        .card-content(@type);
    }

    .uk-dropdown{
        .dropdown(@type);

        ul > li {
            color: @text !important;
        }
    }

    button.uk-button-default{
        .button-default(@type);
        
        &:hover{
            .button-hover(@type);
        }
    }

    input.uk-input{
        .input-default(@type);

        &:focus{
            .input-default-focus(@type);
        }
    }
}
